Imports System.IO
Imports System.Exception
Imports System.Text
Imports System.Security.Cryptography



Partial Class _Default
    Inherits System.Web.UI.Page


    Private Function Hash1(ByVal Str As String)
        Dim Str1 As String
        Dim BitsInUnignedInt As Integer
        Dim OneEighth As Integer
        Dim ThreeQuarters As Integer
        Dim HighBits As Integer
        Dim Hash As Integer = 0
        Dim test As Integer = 0
        Dim i As Integer = 0

        BitsInUnignedInt = 4 * 8
        ThreeQuarters = Int((BitsInUnignedInt * 3) / 4)
        OneEighth = Int(BitsInUnignedInt / 8)
        HighBits = Int((&HFFFFFFFF) << (BitsInUnignedInt - OneEighth))

        For i = 1 To Len(Str)
            Hash = (Hash << OneEighth) + Asc(Mid(Str, i, 1))
            test = Hash And HighBits
            If test <> 0 Then
                Hash = ((Hash Xor (test << ThreeQuarters)) And Not HighBits)
            End If
        Next i

        Hash = Hash And &H7FFFFFFF

        Str1 = Hex(Hash)


        Str1 = LCase(Mid(Str1, Int(Len(Str) / 2), 2)) + Mid(Str1, 1, Int(Len(Str1) / 2)) + Mid(Str1, Len(Str1) - 1, 2) + LCase(Mid(Str1, Int(Len(Str1) / 2), 2)) + Mid(Str1, Int(Len(Str1) / 2 + 1), Int(Len(Str1) / 2 - 1)) + Mid(Str1, Len(Str) - 1, Int(Len(Str1) / 4))


        Return (Str1)
    End Function


    Private Function Hash2(ByVal Str As String)
        Dim fnv_prime As Integer
        Dim hash As Double
        Dim i As Integer
        Dim j As Integer
        Dim num As String
        Dim Value As String
        Dim Str2 As String

        Value = vbNullString
        fnv_prime = 179424673 'the 10000000th prime
        hash = &H55555555

        For i = 1 To Len(Str)
            hash *= fnv_prime
            hash *= Asc(Mid(Str, i, 1))
        Next i

        Str2 = hash
        Str2 = Mid(Str2, 3, 14)

        For j = 1 To Len(Str2)
            num = Mid(Str2, j, 2)   'num is a 2 digits
            If (Val(num) < 33) Then
                Value = Value & Chr(Val(num) + 33)
            Else
                Value = Value & Chr(Val(num))
            End If
        Next j

        Return (Value)
    End Function

    Private Function MD5Hash(ByVal Str As String) As String
        'Create an encoding object to ensure the encoding standard for the source text
        Dim Ue As New UnicodeEncoding()

        'Retrieve a byte array based on the source text
        Dim ByteSourceText() As Byte = Ue.GetBytes(Str)

        'Instantiate an MD5 Provider object
        Dim Md5 As New MD5CryptoServiceProvider()

        'Compute the hash value from the source
        Dim ByteHash() As Byte = Md5.ComputeHash(ByteSourceText)

        'And convert it to String format for return

        Return Convert.ToBase64String(ByteHash)
    End Function

    Private Function SHA1Hash(ByVal Str As String) As String
        'Create an encoding object to ensure the encoding standard for the source text
        Dim Ue As New UnicodeEncoding()

        'Retrieve a byte array based on the source text
        Dim ByteSourceText() As Byte = Ue.GetBytes(Str)

        'Instantiate an MD5 Provider object
        Dim SHA1 As New SHA1CryptoServiceProvider()

        'Compute the hash value from the source
        Dim ByteHash() As Byte = SHA1.ComputeHash(ByteSourceText)

        'And convert it to String format for return

        Return Convert.ToBase64String(ByteHash)
    End Function
    Private Function SHA256Hash(ByVal Str As String) As String
        'Create an encoding object to ensure the encoding standard for the source text
        Dim Ue As New UnicodeEncoding()

        'Retrieve a byte array based on the source text
        Dim ByteSourceText() As Byte = Ue.GetBytes(Str)

        'Instantiate an MD5 Provider object
        Dim SHA256 As New SHA256Managed()

        'Compute the hash value from the source
        Dim ByteHash() As Byte = SHA256.ComputeHash(ByteSourceText)

        'And convert it to String format for return

        Return Convert.ToBase64String(ByteHash)
    End Function
    Private Function SHA384Hash(ByVal Str As String) As String
        'Create an encoding object to ensure the encoding standard for the source text
        Dim Ue As New UnicodeEncoding()

        'Retrieve a byte array based on the source text
        Dim ByteSourceText() As Byte = Ue.GetBytes(Str)

        'Instantiate an MD5 Provider object
        Dim SHA384 As New SHA384Managed()

        'Compute the hash value from the source
        Dim ByteHash() As Byte = SHA384.ComputeHash(ByteSourceText)

        'And convert it to String format for return

        Return Convert.ToBase64String(ByteHash)
    End Function
    Private Function SHA512Hash(ByVal Str As String) As String
        'Create an encoding object to ensure the encoding standard for the source text
        Dim Ue As New UnicodeEncoding()

        'Retrieve a byte array based on the source text
        Dim ByteSourceText() As Byte = Ue.GetBytes(Str)

        'Instantiate an MD5 Provider object
        Dim SHA512 As New SHA512Managed()

        'Compute the hash value from the source
        Dim ByteHash() As Byte = SHA512.ComputeHash(ByteSourceText)

        'And convert it to String format for return

        Return Convert.ToBase64String(ByteHash)
    End Function

    Private Function WebDomain(ByVal Str As String) As String

        Dim charStart As Integer = 0

        Dim j As Integer

        'Extracting the domain name
        If Mid(Str, 1, 7) = "http://" Then
            Str = Mid(Str, 8, Len(Str))
        End If

        If Mid(Str, 1, 8) = "https://" Then
            Str = Mid(Str, 9, Len(Str))
        End If

        If Mid(Str, 1, 4) = "www." Then
            Str = Mid(Str, 5, Len(Str))
        End If


        'Removing everything after the slash character
        For j = 1 To Len(Str)
            If Mid(Str, j, 1) = "/" Then
                Exit For
            End If
        Next j

        charStart = 1

        Return Mid(Str, charStart, j - charStart)
    End Function

    Private Function HPwdLen(ByVal Str As String, ByVal length As Integer) As String

        Return Mid(Str, 1, length)
    End Function

    Protected Sub Hashbtn_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Hashbtn.Click
        Dim HPwd As String
        Dim HUser As String
        Dim i As Integer

        'Choosing which algorithms to use

        'HPwd = MD5Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        HPwd = SHA1Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        'HPwd = SHA256Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        'HPwd = SHA384Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        'HPwd = SHA512Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))

        HUser = MD5Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        'HUser = SHA1Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        'HUser = SHA256Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        'HUser = SHA384Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        'HUser = SHA512Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
        For i = 1 To Len(HUser)
            If Mid(HUser, i, 1) = "0" Then
                Mid(HUser, i, 1) = "A"
            End If
            If Mid(HUser, i, 1) = "1" Then
                Mid(HUser, i, 1) = "b"
            End If
            If Mid(HUser, i, 1) = "2" Then
                Mid(HUser, i, 1) = "z"
            End If
            If Mid(HUser, i, 1) = "3" Then
                Mid(HUser, i, 1) = "M"
            End If
            If Mid(HUser, i, 1) = "4" Then
                Mid(HUser, i, 1) = "i"
            End If
            If Mid(HUser, i, 1) = "5" Then
                Mid(HUser, i, 1) = "l"
            End If
            If Mid(HUser, i, 1) = "6" Then
                Mid(HUser, i, 1) = "T"
            End If
            If Mid(HUser, i, 1) = "7" Then
                Mid(HUser, i, 1) = "s"
            End If
            If Mid(HUser, i, 1) = "8" Then
                Mid(HUser, i, 1) = "E"
            End If
            If Mid(HUser, i, 1) = "9" Then
                Mid(HUser, i, 1) = "P"
            End If
        Next
        HUser = HUser


        If Hrbtn2.Checked = True Then
            'HPwd = MD5Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            'HPwd = SHA1Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            'HPwd = SHA256Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            'HPwd = SHA384Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            HPwd = SHA512Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))

            'HUser = MD5Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            'HUser = SHA1Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            'HUser = SHA256Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            HUser = SHA384Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            'HUser = SHA512Hash(Pwdtxt.Text + WebDomain(Webtxt.Text))
            For i = 1 To Len(HUser)
                If Mid(HUser, i, 1) = "0" Then
                    Mid(HUser, i, 1) = "A"
                End If
                If Mid(HUser, i, 1) = "1" Then
                    Mid(HUser, i, 1) = "b"
                End If
                If Mid(HUser, i, 1) = "2" Then
                    Mid(HUser, i, 1) = "z"
                End If
                If Mid(HUser, i, 1) = "3" Then
                    Mid(HUser, i, 1) = "M"
                End If
                If Mid(HUser, i, 1) = "4" Then
                    Mid(HUser, i, 1) = "i"
                End If
                If Mid(HUser, i, 1) = "5" Then
                    Mid(HUser, i, 1) = "l"
                End If
                If Mid(HUser, i, 1) = "6" Then
                    Mid(HUser, i, 1) = "T"
                End If
                If Mid(HUser, i, 1) = "7" Then
                    Mid(HUser, i, 1) = "s"
                End If
                If Mid(HUser, i, 1) = "8" Then
                    Mid(HUser, i, 1) = "E"
                End If
                If Mid(HUser, i, 1) = "9" Then
                    Mid(HUser, i, 1) = "P"
                End If
            Next
            HUser = HUser

        End If

        If HPwdLength.SelectedIndex = 13 Then

            HPwdtxt.Text = HPwdLen(HPwd, 20)

            HUsertxt.Text = HPwdLen(HUser, 20)
        Else

            HPwdtxt.Text = HPwdLen(HPwd, HPwdLength.SelectedValue)

            HUsertxt.Text = HPwdLen(HUser, HPwdLength.SelectedValue)

        End If

    End Sub

    Protected Sub Webtxt_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Webtxt.TextChanged
        Dim URL As String
        URL = Webtxt.Text
        
        If Mid(URL, 1, 4) <> "http" And Mid(URL, 1, 3) <> "www" Then
            URL = "http://" + URL
        End If
        If Mid(URL, 1, 4) <> "http" And Mid(URL, 1, 3) = "www" Then
            URL = "http://" + URL
        End If
        Webtxt.Text = WebDomain(Webtxt.Text)
        HyperLink1.NavigateUrl = URL
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim URL As String
        URL = Webtxt.Text
        
        If Mid(URL, 1, 4) <> "http" And Mid(URL, 1, 3) <> "www" Then
            URL = "http://" + URL
        End If
        If Mid(URL, 1, 4) <> "http" And Mid(URL, 1, 3) = "www" Then
            URL = "http://" + URL
        End If
        HyperLink1.NavigateUrl = URL
    End Sub

    Protected Sub HPwdLength_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles HPwdLength.SelectedIndexChanged
        If HPwdLength.SelectedIndex = 0 Then
            HPwdLength.SelectedValue = 20
        ElseIf HPwdLength.SelectedIndex = 1 Then
            HPwdLength.SelectedValue = 19
        ElseIf HPwdLength.SelectedIndex = 2 Then
            HPwdLength.SelectedValue = 18
        ElseIf HPwdLength.SelectedIndex = 3 Then
            HPwdLength.SelectedValue = 17
        ElseIf HPwdLength.SelectedIndex = 4 Then
            HPwdLength.SelectedValue = 16
        ElseIf HPwdLength.SelectedIndex = 5 Then
            HPwdLength.SelectedValue = 15
        ElseIf HPwdLength.SelectedIndex = 6 Then
            HPwdLength.SelectedValue = 14
        ElseIf HPwdLength.SelectedIndex = 7 Then
            HPwdLength.SelectedValue = 13
        ElseIf HPwdLength.SelectedIndex = 8 Then
            HPwdLength.SelectedValue = 12
        ElseIf HPwdLength.SelectedIndex = 9 Then
            HPwdLength.SelectedValue = 11
        ElseIf HPwdLength.SelectedIndex = 10 Then
            HPwdLength.SelectedValue = 10
        ElseIf HPwdLength.SelectedIndex = 11 Then
            HPwdLength.SelectedValue = 9
        ElseIf HPwdLength.SelectedIndex = 12 Then
            HPwdLength.SelectedValue = 8
        End If
    End Sub

End Class
